From oracle-l-bounce@freelists.org  Tue Mar 29 09:47:01 2005
Return-Path: <oracle-l-bounce@freelists.org>
Received: from air891.startdedicated.com (root@localhost)
 by orafaq.com (8.12.10/8.12.10) with ESMTP id j2TFkxww022233
 for <oracle-l@orafaq.com>; Tue, 29 Mar 2005 09:47:01 -0600
X-ClientAddr: 206.53.239.180
Received: from turing.freelists.org (freelists-180.iquest.net [206.53.239.180])
 by air891.startdedicated.com (8.12.10/8.12.10) with ESMTP id j2TFkxem022226
 for <oracle-l@orafaq.com>; Tue, 29 Mar 2005 09:46:59 -0600
Received: from localhost (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id 7670789E70;
 Tue, 29 Mar 2005 09:45:04 -0500 (EST)
Received: from turing.freelists.org ([127.0.0.1])
 by localhost (turing [127.0.0.1]) (amavisd-new, port 10024)
 with ESMTP id 03316-04; Tue, 29 Mar 2005 09:45:04 -0500 (EST)
Received: from turing (localhost [127.0.0.1])
 by turing.freelists.org (Avenir Technologies Mail Multiplex) with ESMTP id E3DF389E4E;
 Tue, 29 Mar 2005 09:45:03 -0500 (EST)
X-MimeOLE: Produced By Microsoft Exchange V6.0.6603.0
content-class: urn:content-classes:message
MIME-Version: 1.0
Content-type: text/plain; charset=US-ASCII
Content-Transfer-Encoding: 8bit
Subject: RE: Passing arrays/objects to Java Stored Procedures?
Date: Tue, 29 Mar 2005 09:43:15 -0500
Message-ID: <D17DB304A9F42B4787B68861F9DAE61CD10235@wgdc02.wgenhq.net>
X-MS-Has-Attach: 
X-MS-TNEF-Correlator: 
Thread-Topic: Passing arrays/objects to Java Stored Procedures?
Thread-Index: AcUzy2Awc90tOtvKS/mvGy1g0s4vdAAn0aSQ
From: "Anthony Molinaro" <amolinaro@wgen.net>
To: <srospo@vallent.com>, <oracle-l@freelists.org>
X-archive-position: 17779
X-ecartis-version: Ecartis v1.0.0
Sender: oracle-l-bounce@freelists.org
Errors-To: oracle-l-bounce@freelists.org
X-original-sender: amolinaro@wgen.net
Precedence: normal
Reply-To: amolinaro@wgen.net
X-list: oracle-l
X-Virus-Scanned: by amavisd-new-20030616-p9 (Debian) at avenirtech.net
X-Spam-Checker-Version: SpamAssassin 2.60 (1.212-2003-09-23-exp) on 
 air891.startdedicated.com
X-Spam-Status: No, hits=0.2 required=5.0 tests=AWL,EXCUSE_16 autolearn=no 
 version=2.60
X-Spam-Level: 

Steve,
  I think the most helpful thing to remember
  is things like oracle objects and records can easily
  be mimicked with C structs.

  So, when returning an array of those types
  you just need to use an array of structs or an
  array of objects (you just need to map a java type
  to the db type and you're ready to go).

  Here's simple example for JDBC (I don't use java=20
  procs in the db, but I imagine to convert
  my example to a java stored proc is trivial).

Here is the oracle object, array, and a function
That returns the array of objects:

create type demo_obj as object( val1 number, val2 number, val3 number );
/

create type demo_array as table of demo_obj;
/

create or replace function f_demo ( p_num number )
return demo_array=20
as=20
    l_array demo_array :=3D demo_array();
begin
    select
demo_obj(round(dbms_random.value(1,1000)),round(dbms_random.value(1,1000
)),round(dbms_random.value(1,1000)))=20
      bulk collect into l_array=20
      from all_objects=20
     where rownum <=3D p_num;=20
    return l_array;
end;
/


here's a little jdbc demo (just a single java class).
Pass in a number at the command line to change the number
or rows returned.

---------------------------------------------------------

import java.lang.*;
import java.sql.*;
import java.io.*;
import oracle.sql.*;
import oracle.jdbc.*;

public class arrayDemo
{
  public static void main( String args[] ) throws IOException,
SQLException
  {
    DriverManager.registerDriver( new oracle.jdbc.driver.OracleDriver()
);
    Connection conn =3D DriverManager.getConnection (
"jdbc:oracle:oci:@YOUR_DB", "SCOTT", "TIGER" );
    conn.setAutoCommit( false );

    Integer numRows =3D new Integer(args[0]);  // variable to accept the
number of rows to return (passed at runtime)

    Object attributes[] =3D new Object[3]; // "attributes" of the =
demo_obj
in the db
    // object demo_obj in the db has 3 fields, all numeric
    // create an array of objects which has 3 attributes
    // we are building a template of that db object
    // the values i pass below are just generic numbers, 1,2,3 mean
nothing really
    attributes[0] =3D new Integer(1);       =20
    attributes[1] =3D new Integer(2);
    attributes[2] =3D new Integer(3);

    // this will represent the data type DEMO_OBJ in the database
    Object demo_obj[] =3D new Object[1];
    =20
    // make the connection between oracle <-> jdbc type
    demo_obj[0] =3D new oracle.sql.STRUCT (new
oracle.sql.StructDescriptor("DEMO_OBJ",conn),conn,attributes);
   =20
    // the function returns an array (collection) of the demo_obj
    // make the connection between that array(demo_array) and a jdbc
array
    oracle.sql.ARRAY demo_array =3D new oracle.sql.ARRAY (new
oracle.sql.ArrayDescriptor("DEMO_ARRAY",conn),conn,demo_obj);

    // call the plsql function
    OracleCallableStatement cs =3D
(OracleCallableStatement)conn.prepareCall ("BEGIN ? :=3D F_DEMO(?);
END;");

    // bind variables
    cs.registerOutParameter (1,OracleTypes.ARRAY,"DEMO_ARRAY");
    cs.setInt (2,numRows.intValue());

    cs.execute();

    // get the results of the oracle array into a local jdbc array=20
    oracle.sql.ARRAY results =3D (oracle.sql.ARRAY)cs.getArray(1);

    // flip it into a result set
    ResultSet rs =3D results.getResultSet();

    // process the result set
    while (rs.next()) {

        // since it's an array of objects, get and display the value of
the underlying object
        oracle.sql.STRUCT obj =3D (STRUCT)rs.getObject(2);

        Object vals[] =3D obj.getAttributes();

        System.out.println (vals[0] + " " + vals[1] + " " + vals[2]);
    }

    // cleanup
    cs.close();
    conn.close(); =20
  }
}

-----------------------------------------------

I just ran it, works fine. I imagine it works the same
way for a java stored proc with maybe some small modifications.

Good luck,
  Anthony


-----Original Message-----
From: oracle-l-bounce@freelists.org
[mailto:oracle-l-bounce@freelists.org] On Behalf Of Steve Rospo
Sent: Monday, March 28, 2005 2:18 PM
To: oracle-l@freelists.org
Subject: Passing arrays/objects to Java Stored Procedures?


Does anyone have examples of passing PL/SQL arrays and/or objects into
Java Stored Procedures?  I can find plenty of examples of passing
scalars
but I can't find more complex examples with collections or objects.


--=20
Stephen Rospo        Principal Software Architect
Vallent Corporation (formerly Watchmark-Comnitel)
Stephen.Rospo@vallent.com           (425)564-8145

This email may contain confidential information. If you received this in
error, please notify the sender immediately by return email and delete
this
message and any attachments. Thank you.

--
http://www.freelists.org/webpage/oracle-l
--
http://www.freelists.org/webpage/oracle-l

